/*******************************************************************************
 * JMMC project ( http://www.jmmc.fr ) - Copyright (C) CNRS.
 ******************************************************************************/
/*
 * Beginner's code which generates test files for aspro2
 * This code can be executed from LITproWrapper test directory using the proper
 * yorick version.
 *
 */

#include "../yoga/LITpro/yorick/LITpro.i"
#include "../yoga/LITpro/yorick/LITpro_practice.i"

world = load_model(LIT_MODELS+"asproSettings.i");

func genFits(filename, img,cdelt1, cdelt2, crval1,crval2, crpix1, crpix2)
{
    fh = fits_create(filename,bitpix=-32,dimlist=dimsof(img));

    fits_set, fh, "CDELT1", cdelt1;
    fits_set, fh, "CDELT2", cdelt2;
    fits_set, fh, "CRVAL1", crval1;
    fits_set, fh, "CRVAL2", crval2;
    fits_set, fh, "CRPIX1", crpix1;
    fits_set, fh, "CRPIX2", crpix2;
    fits_set, fh, "COMMENT","Generated by genAsproTestFiles.i batch";
    fits_write_header, fh;

    fits_write_array ,fh ,img;
    
    fits_close, fh;
}

for (i=1 ; i<=3 ; i++)
{
filename_prefix="out/"+swrite( format="%d",i);

filename = filename_prefix+"_uvmap.pdf";
print,"generates "+filename;
winkill
lp_plot_uvmap, world,i,no_data=1;
pdf, filename 

winkill
xmin=-30;
xmax=30;
ymin=-30;
ymax=30;
pixscale=1;
filename = filename_prefix+"_image.pdf";
print,"generates "+filename;
lp_plot_image,world,i,xmin=xmin, xmax=xmax, ymin=ymin , ymax=ymax, pixscale=pixscale;
pdf, filename 

filename=filename_prefix+"_image.fits";
print,"generates "+filename;
img=lp_plot_image(world,i,xmin=xmin, xmax=xmax, ymin=ymin , ymax=ymax, pixscale=pixscale);
x1=sign(xmin)*ceil(abs(xmin)/pixscale)*pixscale
x2=sign(xmax)*ceil(abs(xmax)/pixscale)*pixscale
y1=sign(ymin)*ceil(abs(ymin)/pixscale)*pixscale
y2=sign(ymax)*ceil(abs(ymax)/pixscale)*pixscale
crpix1 = 1.0 + ( -x1 / ( x2 - x1 )) * (dimsof(img)(2) - 1);
crpix2 = 1.0 + ( -y1 / ( y2 - y1 )) * (dimsof(img)(3) - 1);
genFits,filename, img, pixscale, pixscale, 0.0, 0.0, crpix1, crpix2;

}
